//--------------------------------------------------------------------
//     此代码由T4模板自动生成  byzhouhang 20210918
//	   生成时间 2023-02-13 10:33:22 
//     对此文件的更改可能会导致不正确的行为，并且如果重新生成代码，这些更改将会丢失。
//--------------------------------------------------------------------

using IRaCIS.Core.Domain.Models;
using Microsoft.AspNetCore.Mvc;
using IRaCIS.Core.Application.Interfaces;
using IRaCIS.Core.Application.ViewModel;
namespace IRaCIS.Core.Application.Service
{	
	/// <summary>
	/// 快捷键服务
	/// </summary>	
	[ApiExplorerSettings(GroupName = "Reading")]
	public class ShortcutKeyService: BaseService
    {
        private readonly IRepository<Dictionary> _dictionaryRepository;
        private readonly IRepository<ShortcutKey> _shortcutKeyRepository;

		public ShortcutKeyService(
			IRepository<Dictionary> DictionaryRepository,
			IRepository<ShortcutKey> shortcutKeyRepository
			)
		{
            _dictionaryRepository = DictionaryRepository;
            _shortcutKeyRepository = shortcutKeyRepository;        
		}


		/// <summary>
		/// 获取医生快捷键
		/// </summary>
		/// <param name="inQuery"></param>
		/// <returns></returns>
		[HttpPost]
		public async Task<List<DefaultShortcutKeyView>> GetDoctorShortcutKey(DefaultShortcutKeyQuery inQuery)
		{
			var shortcutKeyList = await _shortcutKeyRepository.Where(x => x.ImageToolType == inQuery.ImageToolType)
				.Where(x=>x.UserId==_userInfo.Id)
				.ToListAsync();

			var defaultshortcutKeyList = this.GetDefaultShortcutKey();

			var shortcutKeydic = await _dictionaryRepository.Where(x => x.Parent.Code == "ShortcutKey")
				.WhereIf(inQuery.ShortcutKeyEnum != null, x => x.Code == inQuery.ShortcutKeyEnum.ToString()).ToListAsync();


			List<DefaultShortcutKeyView> result = new List<DefaultShortcutKeyView>();

			shortcutKeydic.OrderBy(x => x.ShowOrder).ForEach(x =>
			{
				var key = shortcutKeyList.Where(y => y.ShortcutKeyEnum == int.Parse(x.Code)).FirstOrDefault();
				var defaultkey= defaultshortcutKeyList.Where(y => y.ShortcutKeyEnum == int.Parse(x.Code)).FirstOrDefault();
				var isnull = key == null;

				result.Add(new DefaultShortcutKeyView()
				{
					Id = x.Id,
					ImageToolType = inQuery.ImageToolType,
					ShortcutKeyEnum = int.Parse(x.Code),
					Keyboardkey = isnull ? defaultkey.Keyboardkey : key.Keyboardkey,
					AltKey = isnull ? false : key.AltKey,
					CtrlKey = isnull ? false : key.CtrlKey,
					MetaKey = isnull ? false : key.MetaKey,
					ShiftKey = isnull ? false : key.ShiftKey,
					KeyboardShow = isnull ? defaultkey.KeyboardShow : key.KeyboardShow,
				});

			});



			return result;
		}

		/// <summary>
		/// 获取默认快捷键
		/// </summary>
		/// <returns></returns>
		private List<ShortcutKey> GetDefaultShortcutKey()
        {
			List<ShortcutKey> shortcutKeys = new List<ShortcutKey>() {
			new ShortcutKey (){ ShortcutKeyEnum=1,Keyboardkey="right",KeyboardShow="right" },
			new ShortcutKey (){ ShortcutKeyEnum=2,Keyboardkey="left",KeyboardShow="left"},
			new ShortcutKey (){ ShortcutKeyEnum=3,Keyboardkey="PageUp",KeyboardShow="PageUp"},
			new ShortcutKey (){ ShortcutKeyEnum=4,Keyboardkey="pageDown",KeyboardShow="pageDown"},
			new ShortcutKey (){ ShortcutKeyEnum=5,Keyboardkey="Up",KeyboardShow="Up"},
			new ShortcutKey (){ ShortcutKeyEnum=6,Keyboardkey="Down",KeyboardShow="Down"},
			new ShortcutKey (){ ShortcutKeyEnum=7,Keyboardkey="L",KeyboardShow="L"},
			new ShortcutKey (){ ShortcutKeyEnum=8,Keyboardkey="R",KeyboardShow="R"},
			new ShortcutKey (){ ShortcutKeyEnum=9,Keyboardkey="H",KeyboardShow="H"},
			new ShortcutKey (){ ShortcutKeyEnum=10,Keyboardkey="V" ,KeyboardShow="V"},
			new ShortcutKey (){ ShortcutKeyEnum=11,Keyboardkey="+" ,KeyboardShow="+"},
			new ShortcutKey (){ ShortcutKeyEnum=12,Keyboardkey="-" ,KeyboardShow="-"},
			new ShortcutKey (){ ShortcutKeyEnum=13,Keyboardkey="=" ,KeyboardShow="="},
			new ShortcutKey (){ ShortcutKeyEnum=14,Keyboardkey="F" ,KeyboardShow="F"},
			new ShortcutKey (){ ShortcutKeyEnum=15,Keyboardkey="S" ,KeyboardShow="S"},
			new ShortcutKey (){ ShortcutKeyEnum=16,Keyboardkey="I" ,KeyboardShow="I"},
			new ShortcutKey (){ ShortcutKeyEnum=17,Keyboardkey="C" ,KeyboardShow="C"},
			new ShortcutKey (){ ShortcutKeyEnum=18,Keyboardkey="Space" ,KeyboardShow="Space"},
			};

			return shortcutKeys;


		}

		/// <summary>
		/// 重置为默认快捷键
		/// </summary>
		/// <returns></returns>
		[HttpPost]
		public async Task<bool> RestoreDefaultShortcutKey(RestoreDefaultShortcutKeyInDto inDto)
		{
		    var shortcutKeys = GetDefaultShortcutKey();
			shortcutKeys.ForEach(x => {
				x.UserId = _userInfo.Id;
			});

			await _shortcutKeyRepository.BatchDeleteNoTrackingAsync(x => x.ImageToolType == inDto.ImageToolType && x.UserId == _userInfo.Id);

			await _shortcutKeyRepository.AddRangeAsync(shortcutKeys.Select(x => new ShortcutKey()
			{
				ImageToolType = inDto.ImageToolType,
				Keyboardkey = x.Keyboardkey,
				ShortcutKeyEnum = x.ShortcutKeyEnum,
				UserId = _userInfo.Id,
				AltKey = x.AltKey,
				CtrlKey = x.CtrlKey,
				MetaKey = x.MetaKey,
				ShiftKey = x.ShiftKey,
				KeyboardShow = x.KeyboardShow,
			}));

			return await _shortcutKeyRepository.SaveChangesAsync();
		}

		/// <summary>
		/// 设置快捷键
		/// </summary>
		/// <param name="inDto"></param>
		/// <returns></returns>
		[HttpPost]
		public async Task<bool> SetShortcutKey(SetDefaultShortcutKey inDto)
		{
			await _shortcutKeyRepository.BatchDeleteNoTrackingAsync(x => x.ImageToolType == inDto.ImageToolType&&x.UserId==_userInfo.Id);

			await _shortcutKeyRepository.AddRangeAsync(inDto.ShortcutKeyList.Select(x => new ShortcutKey()
			{
				ImageToolType = inDto.ImageToolType,
				Keyboardkey = x.Keyboardkey,
				ShortcutKeyEnum = x.ShortcutKeyEnum,
				UserId=_userInfo.Id,
				AltKey=x.AltKey,
				CtrlKey=x.CtrlKey,
				MetaKey=x.MetaKey,
				ShiftKey=x.ShiftKey,
				KeyboardShow=x.KeyboardShow,
			}));

		   return	await _shortcutKeyRepository.SaveChangesAsync();
		}




	}
} 
